package spam.evaluation;

import com.hp.hpl.jena.sparql.algebra.Op;
import com.hp.hpl.jena.sparql.algebra.Table;
import com.hp.hpl.jena.sparql.algebra.op.OpBGP;
import com.hp.hpl.jena.sparql.algebra.op.OpJoin;
import com.hp.hpl.jena.sparql.algebra.op.OpLeftJoin;
import com.hp.hpl.jena.sparql.algebra.op.OpProject;
import com.hp.hpl.jena.sparql.engine.ref.Evaluator;

public class EvaluatorWellDesigned {

    private Evaluator evaluator;

    public EvaluatorWellDesigned(Evaluator ev) {
        evaluator = ev;
    }

    public Table eval(Op op, Table Omega) {
        if (Omega.isEmpty()) {
            return Omega;
        }
        if (op.getClass() == OpProject.class) {
            OpProject op2 = (OpProject) op;
            return evaluator.project(eval(op2.getSubOp(), Omega), op2.getVars());
        }
        if (op.getClass() == OpJoin.class) {
            OpLeftJoin op2 = (OpLeftJoin) op;
            Table left = eval(op2.getLeft(), Omega);
            Table right = eval(op2.getRight(), left);
            return evaluator.leftJoin(left, right, op2.getExprs());
        }
        if (op.getClass() == OpLeftJoin.class) {
            OpLeftJoin op2 = (OpLeftJoin) op;
            Table left = eval(op2.getLeft(), Omega);
            Table right = eval(op2.getRight(), left);
            return evaluator.leftJoin(left, right, op2.getExprs());
        }
        if (op.getClass() == OpBGP.class) {
            OpBGP op2 = (OpBGP) op;
            Table res = evaluator.basicPattern(op2.getPattern());

            return evaluator.join(res, Omega);
        }
        System.err.println(op.getName());
        return Omega;
    }
}
