/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.gui;

import java.io.File;

import javax.swing.DefaultListModel;

import spam.model.DatasetComponent;

import com.hp.hpl.jena.query.Dataset;
import com.hp.hpl.jena.query.DatasetFactory;

/**
 * Simplifies adding and removing Databases. Singleton
 *
 * @author Andres Letelier
 */
public class DatasetListHandler {

	private final DefaultListModel<DatasetComponent> model;
	private static DatasetListHandler instance;

	public static DatasetListHandler getInstance() {
		if (instance == null) {
			instance = new DatasetListHandler();
		}
		return instance;
	}

	public DefaultListModel<DatasetComponent> getModel() {
		return model;
	}

	private DatasetListHandler() {
		model = new DefaultListModel<DatasetComponent>();
	}

	/**
	 * Add a parsed dataset with a given name to the list
	 *
	 * @param name
	 * @param data
	 */
	public void addDataset(String name, Dataset data) {
		model.addElement(new DatasetComponent(name, data));
	}

	/**
	 * Load a dataset from a file and add it to the list
	 *
	 * @param f
	 */
	public void loadDataset(File f) {
		// we try to parse the query
		Dataset data = DatasetFactory.create(f.toURI().toString());
		model.addElement(new DatasetComponent(f.getName(), data));

	}
}
