/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.gui;

import java.util.List;

import javax.swing.DefaultListModel;

import spam.model.QueryComponent;
import spam.transformationRules.R4Application;
import spam.transformationRules.RuleApplication;
import spam.transformationRules.TransformationUtilities;

/**
 * Manages the list of rule applications for a given query
 *
 * @author Andres Letelier
 */
public class RuleApplicationList {

	private final QueryComponent queryComponent;
	private DefaultListModel<RuleApplication> model;

	List<RuleApplication> rules;

	public DefaultListModel<RuleApplication> getModel() {
		return model;

	}

	/**
	 * Finds every rule application for the given query
	 *
	 * @param q
	 */
	public RuleApplicationList(QueryComponent q) {
		model = new DefaultListModel<RuleApplication>();
		queryComponent = q;
		rules = TransformationUtilities.getApplicableRules(q.getTreePattern());

		for (RuleApplication r : rules) {
			model.addElement(r);
		}
	}

	public void checkAllApplications() {

		int i = 0;
		for (RuleApplication r : rules) {
			r.setListIndex(i);
			r.checkResultIsWellDesigned(queryComponent);
			i++;
		}
	}

	public DefaultListModel<RuleApplication> getFilteredModel() {

		DefaultListModel<RuleApplication> filteredModel = new DefaultListModel<RuleApplication>();

		this.checkAllApplications();

		for (RuleApplication r : rules) {

			if (r.getResultIsWellDesigned()) {
				filteredModel.addElement(r);
			} else {
				if (r instanceof R4Application) {

				} else {
					filteredModel.addElement(r);
				}
			}
		}

		model = filteredModel;
		return model;
	}
}
