/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.gui;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;

import org.jdesktop.layout.GroupLayout;
import org.jdesktop.layout.LayoutStyle;

import spam.exception.PatternTreeFactoryException;
import spam.exception.UnsupportedOperatorForPatternTreeException;
import spam.exception.UnsupportedOperatorForSubsumptionException;
import spam.model.QueryComponent;
import spam.model.TreePattern;
import spam.model.TreePatternFactory;
import spam.service.SubsumptionService;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.graph.NodeFactory;
import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.shared.PrefixMapping;
import com.hp.hpl.jena.sparql.algebra.Algebra;
import com.hp.hpl.jena.sparql.algebra.OpVars;
import com.hp.hpl.jena.sparql.core.Var;

/**
 *
 * @author Andres Letelier
 */
public class SubsumptionGui extends javax.swing.JFrame {

	private static final long serialVersionUID = 1L;

	/**
	 * Creates new form SubsumptionGui
	 */
	public SubsumptionGui() {
		try {
			// Set System L&F
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			System.err.println("Cannot set system look and feel");
			System.err.println(e);
		}
		initComponents();
		this.firstQueryComboBox.setModel(QueryListHandler.getInstance().getCModel1());
		this.secondQueryComboBox.setModel(QueryListHandler.getInstance().getCModel2());

		this.firstQueryComboBoxActionPerformed(null);
		this.secondQueryComboBoxActionPerformed(null);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	private void initComponents() {

		jSplitPane2 = new javax.swing.JSplitPane();
		jPanel1 = new javax.swing.JPanel();
		firstQueryComboBox = new javax.swing.JComboBox<QueryComponent>();
		secondQueryComboBox = new javax.swing.JComboBox<QueryComponent>();
		jSplitPane1 = new javax.swing.JSplitPane();
		secondQueryScrollPane = new javax.swing.JScrollPane();
		firstQueryScrollPane = new javax.swing.JScrollPane();
		jLabel1 = new javax.swing.JLabel();
		jLabel2 = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		testTypeComboBox = new javax.swing.JComboBox<String>();
		runTestButton = new javax.swing.JButton();
		jPanel2 = new javax.swing.JPanel();
		counterexamplePanel = new javax.swing.JPanel();
		counterexampleTableScrollPane = new javax.swing.JScrollPane();
		counterexampleTable = new javax.swing.JTable();
		answerLabel = new javax.swing.JLabel();
		counterexampleTableHeaderLabel = new javax.swing.JLabel();
		countereaxmpleScrollPane = new javax.swing.JScrollPane();
		failedMappingTable = new javax.swing.JTable();
		counterexampleHeaderLabel = new javax.swing.JLabel();
		answerHeadLabel = new javax.swing.JLabel();

		setTitle("SPAM: Static analysis");

		// firstQueryComboBox.setModel(new javax.swing.DefaultComboBoxModel(new
		// String[] { "Q1.q", "Q2.q", "Q3.q" }));
		firstQueryComboBox.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				firstQueryComboBoxActionPerformed(evt);
			}
		});

		// secondQueryComboBox.setModel(new javax.swing.DefaultComboBoxModel(new
		// String[] { "Q1.q", "Q2.q", "Q3.q" }));
		// secondQueryComboBox.setSelectedIndex(2);
		secondQueryComboBox.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				secondQueryComboBoxActionPerformed(evt);
			}
		});

		jSplitPane1.setDividerLocation(350);

		secondQueryScrollPane.setBackground(new java.awt.Color(255, 255, 255));
		jSplitPane1.setRightComponent(secondQueryScrollPane);

		firstQueryScrollPane.setBackground(new java.awt.Color(255, 255, 255));
		jSplitPane1.setLeftComponent(firstQueryScrollPane);

		jLabel1.setText("First query:");

		jLabel2.setText("Second query:");

		jLabel3.setText("Test for");

		testTypeComboBox.setModel(new javax.swing.DefaultComboBoxModel<String>(new String[] { "Subsumption", "Equivalence" }));

		runTestButton.setText("Run test");
		runTestButton.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				runTestButtonActionPerformed(evt);
			}
		});

		GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
		jPanel1.setLayout(jPanel1Layout);
		jPanel1Layout.setHorizontalGroup(jPanel1Layout.createParallelGroup(GroupLayout.LEADING).add(
				jPanel1Layout
						.createSequentialGroup()
						.addContainerGap()
						.add(jPanel1Layout
								.createParallelGroup(GroupLayout.LEADING)
								.add(jSplitPane1)
								.add(jPanel1Layout
										.createSequentialGroup()
										.add(jPanel1Layout.createParallelGroup(GroupLayout.LEADING).add(jLabel2).add(jLabel1))
										.addPreferredGap(LayoutStyle.RELATED)
										.add(jPanel1Layout
												.createParallelGroup(GroupLayout.LEADING)
												.add(jPanel1Layout.createSequentialGroup().add(firstQueryComboBox, GroupLayout.PREFERRED_SIZE, 130, GroupLayout.PREFERRED_SIZE).add(18, 18, 18)
														.add(jLabel3)).add(secondQueryComboBox, GroupLayout.PREFERRED_SIZE, 130, GroupLayout.PREFERRED_SIZE))
										.addPreferredGap(LayoutStyle.RELATED)
										.add(jPanel1Layout.createParallelGroup(GroupLayout.LEADING).add(runTestButton)
												.add(testTypeComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).add(0, 0, Short.MAX_VALUE)))
						.addContainerGap()));
		jPanel1Layout.setVerticalGroup(jPanel1Layout.createParallelGroup(GroupLayout.LEADING).add(
				jPanel1Layout
						.createSequentialGroup()
						.addContainerGap()
						.add(jPanel1Layout.createParallelGroup(GroupLayout.BASELINE).add(jLabel1)
								.add(firstQueryComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE).add(jLabel3)
								.add(testTypeComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addPreferredGap(LayoutStyle.RELATED)
						.add(jPanel1Layout.createParallelGroup(GroupLayout.BASELINE).add(jLabel2)
								.add(secondQueryComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE).add(runTestButton)).addPreferredGap(LayoutStyle.RELATED)
						.add(jSplitPane1, GroupLayout.DEFAULT_SIZE, 423, Short.MAX_VALUE).addContainerGap()));

		jSplitPane2.setLeftComponent(jPanel1);
		jSplitPane2.setDividerLocation(700);

		jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

		counterexamplePanel.setPreferredSize(new java.awt.Dimension(250, 265));

		counterexampleTable.setModel(new javax.swing.table.DefaultTableModel(new Object[][] { { "ex:H", "ex:price", "ex:C" }, { "ex:H", "ex:nearby", "ex:M" }, { "ex:H", "ex:category", "ex:hotel" },
				{ "ex:H", "ex:location", "ex:L" }, { "ex:A", "ex:poi", "ex:P" }, { "ex:A", "ex:location", "ex:L" }, { "ex:M", "ex:location", "ex:L" }, { "ex:M", "ex:rating", "ex:top" },
				{ "ex:M", "ex:poi", "ex:art-museum" } }, new String[] { "Subject", "Predicate", "Object" }) {
			private static final long serialVersionUID = 1L;
			boolean[] canEdit = new boolean[] { false, false, false };

			@Override
			public boolean isCellEditable(int rowIndex, int columnIndex) {
				return canEdit[columnIndex];
			}
		});
		counterexampleTable.setGridColor(new java.awt.Color(0, 0, 0));
		counterexampleTable.setPreferredSize(new java.awt.Dimension(400, 144));
		counterexampleTableScrollPane.setViewportView(counterexampleTable);

		answerLabel.setForeground(new java.awt.Color(255, 0, 0));
		answerLabel.setText("Q1.q is not subsumed by Q3.q");

		counterexampleTableHeaderLabel.setText("Counterexample database");

		failedMappingTable.setModel(new javax.swing.table.DefaultTableModel(new Object[][] { { "ex:H", "ex:C" } }, new String[] { "Variable", "Value" }));
		failedMappingTable.setEditingRow(0);
		failedMappingTable.setGridColor(new java.awt.Color(0, 0, 0));
		failedMappingTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
		countereaxmpleScrollPane.setViewportView(failedMappingTable);

		counterexampleHeaderLabel.setText("Non subsumed mapping:");

		answerHeadLabel.setText("Answer");
		answerHeadLabel.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
		answerHeadLabel.setMaximumSize(new java.awt.Dimension(47, 45));
		answerHeadLabel.setMinimumSize(new java.awt.Dimension(47, 45));
		answerHeadLabel.setPreferredSize(new java.awt.Dimension(47, 45));

		GroupLayout counterexamplePanelLayout = new GroupLayout(counterexamplePanel);
		counterexamplePanel.setLayout(counterexamplePanelLayout);
		counterexamplePanelLayout.setHorizontalGroup(counterexamplePanelLayout
				.createParallelGroup(GroupLayout.LEADING)
				.add(countereaxmpleScrollPane, GroupLayout.DEFAULT_SIZE, 611, Short.MAX_VALUE)
				.add(counterexampleTableScrollPane, GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
				.add(counterexamplePanelLayout.createSequentialGroup()
						.add(counterexamplePanelLayout.createParallelGroup(GroupLayout.LEADING).add(counterexampleTableHeaderLabel).add(counterexampleHeaderLabel)).addContainerGap())
				.add(answerLabel, GroupLayout.DEFAULT_SIZE, 611, Short.MAX_VALUE).add(answerHeadLabel, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE));
		counterexamplePanelLayout.setVerticalGroup(counterexamplePanelLayout.createParallelGroup(GroupLayout.LEADING).add(
				GroupLayout.TRAILING,
				counterexamplePanelLayout.createSequentialGroup().addContainerGap().add(answerHeadLabel, GroupLayout.PREFERRED_SIZE, 57, GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(LayoutStyle.RELATED).add(answerLabel).addPreferredGap(LayoutStyle.RELATED).add(counterexampleTableHeaderLabel).addPreferredGap(LayoutStyle.RELATED)
						.add(counterexampleTableScrollPane, GroupLayout.PREFERRED_SIZE, 188, GroupLayout.PREFERRED_SIZE).addPreferredGap(LayoutStyle.RELATED, 18, Short.MAX_VALUE)
						.add(counterexampleHeaderLabel).addPreferredGap(LayoutStyle.RELATED).add(countereaxmpleScrollPane, GroupLayout.PREFERRED_SIZE, 164, GroupLayout.PREFERRED_SIZE)));

		jPanel2.add(counterexamplePanel);
		jPanel2.remove(counterexamplePanel);
		jPanel2.add(counterexamplePanel, java.awt.BorderLayout.CENTER);

		jSplitPane2.setRightComponent(jPanel2);

		GroupLayout layout = new GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(GroupLayout.LEADING).add(
				layout.createSequentialGroup().addContainerGap().add(jSplitPane2, GroupLayout.DEFAULT_SIZE, 1065, Short.MAX_VALUE).addContainerGap()));
		layout.setVerticalGroup(layout.createParallelGroup(GroupLayout.LEADING).add(layout.createSequentialGroup().addContainerGap().add(jSplitPane2).addContainerGap()));

		pack();
	}

	private boolean queryFitForTest(JComboBox<QueryComponent> combobox, String position) {

		if (combobox.getSelectedItem() != null) {
			QueryComponent q1 = (QueryComponent) combobox.getSelectedItem();
			if (q1.getTreePattern() == null) {
				JOptionPane.showMessageDialog(rootPane, "One of the queries does not have a corresponding pattern tree - Aborting", "No valid pattern tree", JOptionPane.ERROR_MESSAGE);
				return false;
			}
			if (!q1.isQuasiWellDesigned()) {
				JOptionPane.showMessageDialog(rootPane, "One query is not quasi well-designed." + " Can only test quasi well-designed queries - Aborting", "Query not quasi well-designed",
						JOptionPane.ERROR_MESSAGE);
				return false;
			}

		} else {
			JOptionPane.showMessageDialog(rootPane, "No " + position + " query selected - aborting", "Missing query", JOptionPane.ERROR_MESSAGE);
			return false;
		}

		return true;

	}

	private boolean isTestApplicable() {

		boolean validQueries = queryFitForTest(firstQueryComboBox, "first") && queryFitForTest(secondQueryComboBox, "second");

		if (!validQueries)
			return false;

		if (firstQueryComboBox.getSelectedItem() == secondQueryComboBox.getSelectedItem()) {
			JOptionPane.showMessageDialog(rootPane, "The query is compared against itself, hence the query is equivalent. " + "Please select two different queries.", "Same query selected twice!",
					JOptionPane.INFORMATION_MESSAGE);
			return false;
		}

		return true;
	}

	private void runTestButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_runTestButtonActionPerformed

		// TODO: introduce some additional tests like
		// - share the same set of variables, or has a superset of variables
		// - have the same root (for equivalence)

		clearResultArea();

		if (!this.isTestApplicable()) {
			return;
		}

		String selection = testTypeComboBox.getSelectedItem().toString().toLowerCase();

		QueryComponent q1 = (QueryComponent) firstQueryComboBox.getSelectedItem();
		QueryComponent q2 = (QueryComponent) secondQueryComboBox.getSelectedItem();

		if (selection.equals("subsumption")) {
			boolean isSubsumed = false;
			boolean varsMatch = SubsumptionService.compareVarsForSubsumption(q1.getQuery(), q2.getQuery());

			try {
				isSubsumed = SubsumptionService.isSubsumed(Algebra.compile(q1.getQuery()), Algebra.compile(q2.getQuery()));
			} catch (UnsupportedOperatorForSubsumptionException e) {
				JOptionPane.showMessageDialog(rootPane, "One of the queries contains an unsupported operator (FILTER, SELECT)\n Such queries cannot be tested", "Query not allowed",
						JOptionPane.ERROR_MESSAGE);
				return;
			}

			this.showResultArea();
			if (isSubsumed) {

				this.hideCounterexampleArea();
				answerLabel.setText(q1.getQueryName() + " is subsumbed by " + q2.getQueryName());

			} else {

				this.showCounterexampleArea();
				String answerText = q1.getQueryName() + " is not subsumbed by " + q2.getQueryName();

				if (!varsMatch) {
					answerText += ":<br/> " + q2.getQueryName() + " does not contain all variables from " + q1.getQueryName();
				}
				answerLabel.setText("<html>" + answerText + "</html>");

				showCounterexample(1, q1.getQuery().getPrefixMapping(), 1);
			}

		} else if (selection.equals("equivalence")) {
			int equalityResult;
			try {
				equalityResult = SubsumptionService.isEquivalent(Algebra.compile(q1.getQuery()), Algebra.compile(q2.getQuery()));
			} catch (UnsupportedOperatorForSubsumptionException e) {
				JOptionPane.showMessageDialog(rootPane, "One of the queries contains an unsupported operator (FILTER, SELECT)\n Such queries cannot be tested", "Query not allowed",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			this.showResultArea();

			if (equalityResult == 0) {

				this.hideCounterexampleArea();
				answerLabel.setText(q1.getQueryName() + " is equivalent to " + q2.getQueryName());

			} else {

				this.showCounterexampleArea();

				String answer = q1.getQueryName() + " is not equivalent to " + q2.getQueryName() + ":";

				boolean varsMatch = SubsumptionService.compareVarsForEquivalence(q1.getQuery(), q2.getQuery());

				if (!varsMatch) {
					answer += "<br/> the queries do not contain the same variables";
				}

				PrefixMapping prefixes = null;
				if (equalityResult == 1) {
					answer += "<br/>" + q1.getQueryName() + " is not subsumed by " + q2.getQueryName();
					prefixes = q1.getQuery().getPrefixMapping();
				}

				if (equalityResult == 2) {
					answer += "<br/>" + q2.getQueryName() + " is not subsumed by " + q1.getQueryName();
					prefixes = q1.getQuery().getPrefixMapping();
				}

				showCounterexample(2, prefixes, equalityResult);
				answerLabel.setText("<html>" + answer + "</html>");

			}
		}
	}// GEN-LAST:event_runTestButtonActionPerformed

	/**
	 * @author Sebastian Skritek
	 */
	private void clearResultArea() {
		answerLabel.setText("");
		while (counterexampleTable.getRowCount() > 0) {
			((DefaultTableModel) counterexampleTable.getModel()).removeRow(0);
		}
		while (failedMappingTable.getRowCount() > 0) {
			((DefaultTableModel) failedMappingTable.getModel()).removeRow(0);
		}
	}

	/**
	 * formats the triples for the counterexample database and the witness table.
	 * 
	 * Variables are preceded with the (undefined) prefix cex: (counterexample).
	 * 
	 * @param node
	 * @return
	 */
	private String formatCounterexampleOutput(Node node, PrefixMapping prefixes) {
		if (node.isVariable()) {
			return NodeFactory.createURI("cex:" + node.getName()).toString();
		} else {
			return node.toString(prefixes);
		}
	}

	/**
	 * adds the counterexample database to the corresponding UI table and one mapping that proves the non-subsumption into the result UI table.
	 * 
	 * @param type
	 */
	private void showCounterexample(int type, PrefixMapping prefixes, int equalityResult) {

		this.showResultArea();

		// display the database
		Iterator<Triple> triples = SubsumptionService.getFailGraphTriples();
		while (triples.hasNext()) {
			Triple t = triples.next();

			((DefaultTableModel) counterexampleTable.getModel()).addRow(new String[] { formatCounterexampleOutput(t.getSubject(), prefixes), formatCounterexampleOutput(t.getPredicate(), prefixes),
					formatCounterexampleOutput(t.getObject(), prefixes) });
		}

		// display the solution on the database

		// Since the number of possible results can go up quite quickly,
		// we only consider the counterexample defined by the identity
		Set<Var> counterexampleVars = new HashSet<Var>(OpVars.mentionedVars(SubsumptionService.getFailReduction()));

		for (Var var : counterexampleVars) {
			String[] row = { "?" + var.getName(), formatCounterexampleOutput(var.asNode(), prefixes) };
			((DefaultTableModel) failedMappingTable.getModel()).addRow(row);
		}

		// highlight the corresponding subtree
		TreePattern subtree;
		try {
			subtree = TreePatternFactory.create(SubsumptionService.getFailReduction());
		} catch (UnsupportedOperatorForPatternTreeException | PatternTreeFactoryException e) {
			JOptionPane.showMessageDialog(rootPane, "Could not create the tree representation", "Tree Creation Failed", JOptionPane.ERROR_MESSAGE);
			return;
		}

		// TODO: this also depends on the type ....

		QueryComponent component;
		if (type == 1 || (type == 2 && equalityResult == 1)) {
			// highlight in the left query
			component = (QueryComponent) this.firstQueryComboBox.getSelectedItem();
		} else {
			// highlight in the right query
			component = (QueryComponent) this.secondQueryComboBox.getSelectedItem();
		}

		component.setCounterexampleSubtree(subtree);

		component.repaintViewports();
	}

	/**
	 * @author Sebastian Skritek
	 */
	private void firstQueryComboBoxActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_firstQueryComboBoxActionPerformed

		QueryComponent query = (QueryComponent) firstQueryComboBox.getSelectedItem();

		this.invalidateLastResult();

		if (query == null) {
			return;
		}

		firstQueryScrollPane.setViewportView(query.getViewport1());
		query.unsetCounterexampleSubtree();
		query.repaintViewports();

	}// GEN-LAST:event_firstQueryComboBoxActionPerformed

	/**
	 * @author Sebastian Skritek
	 */
	private void secondQueryComboBoxActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_secondQueryComboBoxActionPerformed

		QueryComponent query = (QueryComponent) secondQueryComboBox.getSelectedItem();

		this.invalidateLastResult();

		if (query == null) {
			return;
		}

		secondQueryScrollPane.setViewportView(query.getViewport2());
		query.unsetCounterexampleSubtree();
		query.repaintViewports();

	}// GEN-LAST:event_secondQueryComboBoxActionPerformed

	private void invalidateLastResult() {

		this.clearResultArea();
		this.hideResultArea();

		QueryComponent q1 = (QueryComponent) this.firstQueryComboBox.getSelectedItem();
		QueryComponent q2 = (QueryComponent) this.secondQueryComboBox.getSelectedItem();

		if (q1 != null) {
			q1.unsetCounterexampleSubtree();
			q1.repaintViewports();
		}

		if (q1 != null) {
			q2.unsetCounterexampleSubtree();
			q2.repaintViewports();
		}
	}

	private void showResultArea() {
		this.counterexamplePanel.setVisible(true);
		this.answerHeadLabel.setText("Answer");
	}

	private void showCounterexampleArea() {
		this.setCountexampleAreaVisibility(true);
	}

	private void hideResultArea() {
		// this.counterexamplePanel.setVisible(false);
		this.setCountexampleAreaVisibility(false);
		this.answerHeadLabel.setText("Choose a test");
	}

	private void hideCounterexampleArea() {
		this.setCountexampleAreaVisibility(false);
	}

	private void setCountexampleAreaVisibility(boolean visible) {
		this.counterexampleTableHeaderLabel.setVisible(visible);
		this.counterexampleTableScrollPane.setVisible(visible);
		this.counterexampleHeaderLabel.setVisible(visible);
		this.countereaxmpleScrollPane.setVisible(visible);
	}

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		// </editor-fold>

		/*
		 * Create and display the form
		 */
		java.awt.EventQueue.invokeLater(new Runnable() {

			@Override
			public void run() {
				new SubsumptionGui().setVisible(true);
			}
		});
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JLabel answerHeadLabel;
	private javax.swing.JLabel answerLabel;
	private javax.swing.JScrollPane countereaxmpleScrollPane;
	private javax.swing.JLabel counterexampleHeaderLabel;
	private javax.swing.JPanel counterexamplePanel;
	private javax.swing.JTable counterexampleTable;
	private javax.swing.JLabel counterexampleTableHeaderLabel;
	private javax.swing.JScrollPane counterexampleTableScrollPane;
	private javax.swing.JTable failedMappingTable;
	private javax.swing.JComboBox<QueryComponent> firstQueryComboBox;
	private javax.swing.JScrollPane firstQueryScrollPane;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JSplitPane jSplitPane1;
	private javax.swing.JSplitPane jSplitPane2;
	private javax.swing.JButton runTestButton;
	private javax.swing.JComboBox<QueryComponent> secondQueryComboBox;
	private javax.swing.JScrollPane secondQueryScrollPane;
	private javax.swing.JComboBox<String> testTypeComboBox;
	// End of variables declaration//GEN-END:variables
}
