/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.transformationRules;

import spam.model.QueryComponent;
import spam.model.TreePattern;
import spam.model.TreePatternNode;

/**
 * All rule applications must extend this
 *
 * @author Andres Letelier
 */
public abstract class RuleApplication {

    TreePatternNode node;
    boolean resultIsWellDesignedFlag = true;
    int listIndex;

    /**
     * The type of rule (R1,R2, etc)
     *
     * @return
     */
    public abstract String type();

    /**
     * Applies the transformation to the query
     */
    public abstract void apply();

    @Override
    public String toString() {
        return type();
    }
    
    public TreePatternNode getNode() {
        return this.node;
    }

    public boolean checkResultIsWellDesigned(QueryComponent qc) {
        
        TreePattern clone = qc.getTreePattern().clone();
        RuleApplication clonerule = TransformationUtilities.getApplicableRules(clone).
                    get(this.listIndex);
        clonerule.apply();
        if (clone.checkWellDesigned()) {
            this.resultIsWellDesignedFlag = true;
        } else {
            this.resultIsWellDesignedFlag = false;
        }
        return this.resultIsWellDesignedFlag;
    }
    
    public boolean getResultIsWellDesigned() {
        return this.resultIsWellDesignedFlag;
    }
    
    public void setListIndex(int index) {
        this.listIndex = index;
    }
    
    public int getListIndex() {
        return this.listIndex;
    }
    
    public TreePatternNode getHighlightNode() {
        return this.node;
    }
    
    public abstract String getDescription();
    
    public abstract void highlightNode(QueryComponent queryComponent);
}
