package subPrograms;

import spam.evaluation.QueryEngineExt;
import spam.evaluation.QueryEngineWellDesigned;

import com.hp.hpl.jena.query.Dataset;
import com.hp.hpl.jena.query.DatasetFactory;
import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.query.ResultSetFormatter;
import com.hp.hpl.jena.sparql.engine.main.QueryEngineMain;
import com.hp.hpl.jena.sparql.engine.ref.QueryEngineRef;

public class Evaluation {

	public static void main(String[] args) {
		if (args.length < 3 || !(args[0].equals("wd") || args[0].equals("ref") || args[0].equals("ext") || args[0].equals("arq"))) {
			System.err.println("Usage: java run ENGINE QUERYFILE MODELFILE");
			System.err.println("Engine can be \"arq\", \"ext\", \"wd\" or \"ref\"");
			System.exit(1);
		}
	
		if (args[0].equals("wd")) {
			// System.err.println("WD engine");
			QueryEngineWellDesigned.register();
		} else if (args[0].equals("ext")) {
			// System.err.println("Ext engine");
			QueryEngineExt.register();
		} else if (args[0].equals("ref")) {
			// System.err.println("Ref engine");
			QueryEngineRef.register();
		} else {
			// System.err.println("ARQ's main engine");
			QueryEngineMain.register();
		}
	
		Dataset model = DatasetFactory.create(args[2]);
		Query query = QueryFactory.read(args[1]);
	
		QueryExecution qe = QueryExecutionFactory.create(query, model);
		ResultSet res = qe.execSelect();
		ResultSetFormatter.out(res);
	}

}
