package subPrograms;

import spam.exception.UnsupportedOperatorForSubsumptionException;
import spam.service.SubsumptionService;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.sparql.algebra.Algebra;
import com.hp.hpl.jena.sparql.algebra.Op;

public class Subsumption {

	public static void main(String[] args) {
		Query q1 = QueryFactory.read(args[1]), q2 = QueryFactory.read(args[2]);

		/*
		 * Query q1=QueryFactory.create("select * where {?x ?y ?z OPTIONAL {?x ?a ?b}}"), q2=QueryFactory.create("select * where {?x ?y ?z}");
		 */

		Op op1 = Algebra.compile(q1), op2 = Algebra.compile(q2);
		String out;
		if (args[0].equals("--subsum")) {
			boolean test;
			try {
				test = SubsumptionService.isSubsumed(op1, op2);
			} catch (UnsupportedOperatorForSubsumptionException e) {
				test = false;
			}
			out = "Query 1 is";
			out += test ? " " : " not ";
			out += "subsumed by query 2.";
			System.out.println(out);
			if (!test) {
				System.out.println("Counterexample database:");
				System.out.println(SubsumptionService.failGraph.toString().replaceAll(";", ";\n"));
			}

			try {
				test = SubsumptionService.isSubsumed(op2, op1);
			} catch (UnsupportedOperatorForSubsumptionException e) {
				test = false;
			}
			out = "Query 2 is";
			out += test ? " " : " not ";
			out += "subsumed by query 1.";
			System.out.println(out);

			if (!test) {
				System.out.println("Counterexample database:");
				System.out.println(SubsumptionService.failGraph.toString().replaceAll(";", ";\n"));
			}
		} else {
			out = "Query 1 is";
			try {
				out += SubsumptionService.isEquivalent(op1, op2) == 0 ? " " : " not ";
			} catch (UnsupportedOperatorForSubsumptionException e) {
				out += " not ";
			}
			out += "equivalent to query 2.";
			System.out.println(out);
		}

	}

}
