/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.gui;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.junit.BeforeClass;
import org.junit.Test;

import spam.exception.PatternTreeFactoryException;
import spam.model.QueryComponent;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryFactory;

/**
 *
 * @author Andres Letelier
 */
public class QueryComponentTest {
	static String queryString = "prefix ex: <http://example/> select * where { ?x ex:a ex:b OPTIONAL {ex:c ?x ?y}}";
	static Query q;

	public QueryComponentTest() {
	}

	@BeforeClass
	public static void setUpClass() throws Exception {
		q = QueryFactory.create(queryString);
	}

	/**
	 * Test of getQueryName method, of class QueryComponent.
	 * 
	 * @throws PatternTreeFactoryException
	 */
	@Test
	public void testGetQueryName() throws PatternTreeFactoryException {
		System.out.println("getQueryName");
		QueryComponent instance = new QueryComponent("name", q);
		String result = instance.getQueryName();
		assertEquals("name", result);
	}

	/**
	 * Test of setQueryName method, of class QueryComponent.
	 * 
	 * @throws PatternTreeFactoryException
	 */
	@Test
	public void testSetQueryName() throws PatternTreeFactoryException {
		System.out.println("setQueryName");
		String name = "name";
		QueryComponent instance = new QueryComponent("a", q);
		assertFalse(name.equals(instance.getQueryName()));
		instance.setQueryName(name);
		assertEquals("name", instance.getQueryName());
	}

	/**
	 * Test of setQuery method, of class QueryComponent.
	 * 
	 * @throws PatternTreeFactoryException
	 */
	@Test
	public void testGetSetQuery() throws PatternTreeFactoryException {
		System.out.println("setQuery and getQuery");

		QueryComponent instance = new QueryComponent("name", q);
		assertNotNull(instance.getQuery());
		assertEquals(instance.getQuery(), q);
		instance.setQuery(null);
		assertNull(instance.getQuery());
	}
}
