/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.model;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import spam.exception.PatternTreeFactoryException;
import spam.exception.UnsupportedOperatorForPatternTreeException;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.sparql.algebra.Algebra;
import com.hp.hpl.jena.sparql.algebra.Op;

/**
 *
 * @author Andres Letelier
 */
public class TreePatternFactoryTest {

	public TreePatternFactoryTest() {
	}

	/**
	 * Test of buildTree method, of class TreePatternFactory.
	 * 
	 * @throws UnsupportedOperatorForPatternTreeException
	 * @throws PatternTreeFactoryException
	 */
	@Test
	public void testBuildTree() throws UnsupportedOperatorForPatternTreeException, PatternTreeFactoryException {
		System.out.println("buildTree");
		Query q1 = QueryFactory.create("prefix a: <http://localhost/> select * where {{?A a:name ?N OPTIONAL {?A a:email ?E}} OPTIONAL {?A a:webpage ?W}}");
		Op op1 = Algebra.compile(q1);
		TreePatternNode root = TreePatternFactory.buildTree(op1, new TreePatternNode());
		assertNotNull(root);
		assertEquals("(?A <http://localhost/name> ?N)", root.toString());
		assertEquals(2, root.getChildren().size());
		assertEquals("(?A <http://localhost/email> ?E)", root.getChildren().get(0).toString());
		assertEquals("(?A <http://localhost/webpage> ?W)", root.getChildren().get(1).toString());
		assertTrue(root.getChildren().get(0).getChildren().isEmpty());
		assertTrue(root.getChildren().get(1).getChildren().isEmpty());

		Query q2 = QueryFactory.create("prefix a: <http://localhost/> select * where {?A a:name ?N OPTIONAL {?A a:email ?E OPTIONAL {?A a:webpage ?W}}}");
		Op op2 = Algebra.compile(q2);
		root = TreePatternFactory.buildTree(op2, new TreePatternNode());
		assertNotNull(root);
		assertEquals("(?A <http://localhost/name> ?N)", root.toString());
		assertEquals(1, root.getChildren().size());
		assertEquals("(?A <http://localhost/email> ?E)", root.getChildren().get(0).toString());
		assertEquals("(?A <http://localhost/webpage> ?W)", root.getChildren().get(0).getChildren().get(0).toString());
		assertEquals(1, root.getChildren().get(0).getChildren().size());
		assertTrue(root.getChildren().get(0).getChildren().get(0).getChildren().isEmpty());

	}

}
