/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package spam.model;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import org.junit.Test;

import spam.exception.PatternTreeFactoryException;
import spam.exception.UnsupportedOperatorForPatternTreeException;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.sparql.algebra.Op;
import com.hp.hpl.jena.sparql.algebra.OpAsQuery;

/**
 *
 * @author Andres Letelier
 */
public class TreePatternNodeTest {

	public TreePatternNodeTest() {
	}

	/**
	 * Test of getId method, of class TreePatternNode
	 */
	@Test
	public void testGetId() {
		System.out.println("getId");
		TreePatternNode n1 = new TreePatternNode("?X ?Y ?Z"), n2 = new TreePatternNode("?X ?Y ?W");
		System.out.println(n1.getId());
		System.out.println(n2.getId());
		assertFalse(n1.getId().equals(n2.getId()));
	}

	/**
	 * Test of getId method, of class TreePatternNode
	 */
	@Test
	public void testTreePatternNode() {
		System.out.println("treePatternNode constructor");
		TreePatternNode n = new TreePatternNode("?x ?y ?z");
		assertEquals("(?x ?y ?z)", n.toString());
	}

	/**
	 * Test of toOp method, of class TreePatternNode
	 * 
	 * @throws UnsupportedOperatorForPatternTreeException
	 */
	@Test
	public void testToOp() throws PatternTreeFactoryException {
		System.out.println("toOp");
		// @formatter:off
        String query = "SELECT  *\n"
                + "WHERE\n"
                + "  { ?M <http://localhost/example/poi> <http://localhost/example/art-museum> .\n"
                + "    ?M <http://localhost/example/rating> <http://localhost/example/top>\n"
                + "    OPTIONAL\n"
                + "      { { ?M <http://localhost/example/location> ?L .\n"
                + "          ?H <http://localhost/example/location> ?L .\n"
                + "          ?H <http://localhost/example/category> <http://localhost/example/h>\n"
                + "          OPTIONAL\n"
                + "            { ?A <http://localhost/example/location> ?L .\n"
                + "              ?A <http://localhost/example/poi> ?P\n"
                + "            }\n"
                + "        }\n"
                + "        OPTIONAL\n"
                + "          { { ?H <http://localhost/example/nearby> ?M\n"
                + "              OPTIONAL\n"
                + "                { ?H <http://localhost/example/price> ?C }\n"
                + "            }\n"
                + "            OPTIONAL\n"
                + "              { ?H <http://localhost/example/rating> ?R }\n"
                + "          }\n"
                + "      }\n"
                + "  }\n";
        // @formatter:on
		Query q = QueryFactory.create(query);
		TreePattern instance = TreePatternFactory.create(q);
		Op op = instance.getRoot().toOp();
		assertEquals(query, OpAsQuery.asQuery(op).toString());
	}
}
